clear;
s=%s;
pi=%pi;
i=%i;

//----------------------MATRICES ESPACIO DE ESTADOS---------------------:

A=[0 0 1 0;0 0 0 1;0 586.854 -43.5916 0;0 -915.802 43.5916 0];
B=[0;0;60.2049;-60.2049];
C=[1 0 0 0;0 1 0 0];
D=[0;0];

//----------------------FUNCIONES DE TRANSFERENCIA----------------------:

sistema=syslin('c',A,B,C,D);
fts=ss2tf(sistema);
g=fts(1,1);
f=fts(2,1);

//----------------------------LQG = LQR + LQE---------------------------:

//CONTROLABILIDAD:

Pc=[B A*B (A^2)*B (A^3)*B];
det_Pc=det(Pc); //det_Pc!=0 -> Controlable

//LQR:

Q=[40 0 0 0;0 1500 0 0;0 0 1 0;0 0 0 1];
R=0.01;
[K,P]=lqr(sistema,Q,R);
K=-K;

//LQE:

W=[100 0 0 0;0 100 0 0;0 0 100 0;0 0 0 100];
V=[0.01 0;0 0.01];
[L,P1]=lqe(sistema,W,V);
L=-L;
