clear;
s=%s;
pi=%pi;

//----------------------MATRICES ESPACIO DE ESTADOS---------------------:

A_teo=[0 0 1 0;0 0 0 1;0 691.221 -39.3663 0;0 -1078.67 39.3663 0];
A_aju=[0 0 1 0;0 0 0 1;0 586.854 -43.5916 0;0 -915.802 43.5916 0];
B=[0;0;60.2049;-60.2049];
C=[1 0 0 0;0 1 0 0];
D=[0;0];

//----------------------FUNCIONES DE TRANSFERENCIA----------------------:

g_sin_flex=syslin('c',1.53,0.07*s^2+s);
g_sin_flex_ajustado=syslin('c',1.42,0.08*s^2+s);

ss_teo=syslin('c',A_teo,B,C,D);
tf_teo=ss2tf(syslin('c',A_teo,B,C,D));
g_con_flex=tf_teo(1,1);
f=tf_teo(2,1);

ss_aju=syslin('c',A_aju,B,C,D);
tf_aju=ss2tf(syslin('c',A_aju,B,C,D));
g_con_flex_ajustado=tf_aju(1,1);
f_ajustado=tf_aju(2,1);

//-----------------------------FILTRO NOTCH-----------------------------:

fn=3.4;
omega_n=2*pi*fn;
a=1;
delta=0.5;

g_notch=syslin('c',(s^2+2*delta*omega_n*s+(omega_n^2))*(a*omega_n)*(omega_n/a),(omega_n^2)*(s+a*omega_n)*(s+(omega_n/a)));

clf(0);
scf(0);
bode(g_notch);

//------------------------FTs (CON FLEX) + NOTCH------------------------:

g_con_flex_y_notch=g_con_flex*g_notch;
g_con_flex_ajustado_y_notch=g_con_flex_ajustado*g_notch;


clf(1);
scf(1);
bode([g_con_flex;g_con_flex_y_notch]);

clf(2);
scf(2);
bode([g_con_flex_ajustado;g_con_flex_ajustado_y_notch]);

clf(3);
scf(3);
bode([g_con_flex_y_notch;g_con_flex_ajustado_y_notch]);
